################################################################################
# jobs for qrb5165-2 projects in voxl-cross docker build environment
#
# Note you can combine these with other jobs for combined projects
# see: voxl-cross-template and librc_math
################################################################################

################################################################################
# build and deploy to dev binary repo on every commit to dev
################################################################################

build_cross_qrb5165-2_dev:
  image: voxl-cross
  stage: build
  retry: 1
  rules:
    - if: ($CI_COMMIT_BRANCH == "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  script:
    - /bin/bash clean.sh
    - /bin/bash scripts/check-build-deps-deb.sh qrb5165-2 dev
    - /bin/bash scripts/check-build-script.sh qrb5165-2
    - /bin/bash make_package.sh deb timestamp
    - date
  artifacts:
    expire_in: 20 min
    paths:
      - "*.deb"

deploy_cross_qrb5165-2_dev:
  image: google/cloud-sdk:latest
  stage: deploy
  timeout: 5 minutes
  retry: 1
  needs:
    - job: build_cross_qrb5165-2_dev
  dependencies:
    - build_cross_qrb5165-2_dev
  rules:
    - if: ($CI_COMMIT_BRANCH == "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  variables:
    PLATFORM: qrb5165-2
  script:
    - /bin/bash scripts/deploy-deb-repo.sh
    - date


################################################################################
# build and deploy to public binary deb repo on tag
################################################################################

build_cross_qrb5165-2_tag:
  image: voxl-cross
  stage: build
  retry: 1
  rules:
    - if: (($CI_COMMIT_TAG =~ /^v.*/) || ($CI_COMMIT_TAG =~ /^sdk.*/)) && ($CI_COMMIT_BRANCH != "dev") && ($CI_PIPELINE_SOURCE != "schedule")
  script:
    - /bin/bash clean.sh
    - /bin/bash scripts/check-build-deps-deb.sh qrb5165-2 $CI_COMMIT_TAG
    - /bin/bash scripts/check-build-script.sh qrb5165-2
    - /bin/bash make_package.sh deb
    - date
  artifacts:
    expire_in: 1 month
    paths:
      - "*.deb"

deploy_cross_qrb5165-2_tag:
  image: google/cloud-sdk:latest
  stage: deploy
  timeout: 5 minutes
  retry: 1
  needs:
    - job: build_cross_qrb5165-2_tag
  dependencies:
    - build_cross_qrb5165-2_tag
  rules:
    - if: (($CI_COMMIT_TAG =~ /^v.*/) || ($CI_COMMIT_TAG =~ /^sdk.*/)) && ($CI_PIPELINE_SOURCE != "schedule")
  variables:
    PLATFORM: qrb5165-2
  script:
    - /bin/bash scripts/deploy-deb-repo.sh
    - date


################################################################################
# Run build and deploy on dev and master nightly.
################################################################################

nightly_cross_qrb5165-2_dev:
  image: voxl-cross
  stage: build
  retry: 1
  rules:
    - if: ($CI_COMMIT_BRANCH == "dev") && ($CI_PIPELINE_SOURCE == "schedule")
  script:
    - /bin/bash clean.sh
    - /bin/bash scripts/check-build-deps-deb.sh qrb5165-2 dev
    - /bin/bash scripts/check-build-script.sh qrb5165-2
    - /bin/bash make_package.sh deb timestamp
    - date
  artifacts:
    expire_in: 20 min
    paths:
      - "*.deb"

nightly_cross_qrb5165-2_master:
  image: voxl-cross
  stage: build
  retry: 1
  rules:
    - if: ($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH) && ($CI_PIPELINE_SOURCE == "schedule")
  script:
    - /bin/bash clean.sh
    - /bin/bash scripts/check-build-deps-deb.sh qrb5165-2 staging
    - /bin/bash scripts/check-build-script.sh qrb5165-2
    - /bin/bash make_package.sh deb timestamp
    - date
  artifacts:
    expire_in: 20 min
    paths:
      - "*.deb"

nightly_deploy_cross_qrb5165-2_master:
  image: google/cloud-sdk:latest
  stage: deploy
  timeout: 5 minutes
  retry: 1
  needs:
    - job: nightly_cross_qrb5165-2_master
  dependencies:
    - nightly_cross_qrb5165-2_master
  rules:
    - if: ($CI_COMMIT_BRANCH == "master") && ($CI_PIPELINE_SOURCE == "schedule")
  variables:
    PLATFORM: qrb5165-2
  script:
    - /bin/bash scripts/deploy-deb-repo.sh
    - date

nightly_deploy_cross_qrb5165-2_dev:
  image: google/cloud-sdk:latest
  stage: deploy
  timeout: 5 minutes
  retry: 1
  needs:
    - job: nightly_cross_qrb5165-2_dev
  dependencies:
    - nightly_cross_qrb5165-2_dev
  rules:
    - if: ($CI_COMMIT_BRANCH == "dev") && ($CI_PIPELINE_SOURCE == "schedule")
  variables:
    PLATFORM: qrb5165-2
  script:
    - /bin/bash scripts/deploy-deb-repo.sh
    - date


################################################################################
# Build (but don't deploy) master on commit.
################################################################################

build_cross_qrb5165-2_master:
  image: voxl-cross
  stage: build
  retry: 1
  rules:
    - if: ($CI_COMMIT_TAG == null) && ($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH) && ($CI_PIPELINE_SOURCE != "schedule")
  script:
    - /bin/bash clean.sh
    - /bin/bash scripts/check-build-deps-deb.sh qrb5165-2 staging
    - /bin/bash scripts/check-build-script.sh qrb5165-2
    - /bin/bash make_package.sh deb
    - date
  artifacts:
    expire_in: 1 week
    paths:
      - "*.deb"



